﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace DisableGrid.ViewModel
{
    public class MainViewModel
    {
        public MainViewModel()
        {
        }

        private bool isGridEnabled;
        public bool IsGridEnabled
        {
            get
            {
                return isGridEnabled;
            }
            set
            {
                isGridEnabled = value;
                OnPropertyChanged();
            }
        }

        public ObservableCollection<Book> GetBooks()
        {
            var books = new ObservableCollection<Book>();
            for (int i = 1; i <= 100; i++)
            {
                books.Add(new Book() { BookID = i, Title = "Title" + i.ToString(), Author = "Author" + i.ToString() });
            }

            return books;
        }

        private ObservableCollection<Book> books;

        public ObservableCollection<Book> Books
        {
            get { return books ?? (books = GetBooks()); }
            set { books = value; OnPropertyChanged(); }
        }


        #region INPC

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion 

    }
}
